﻿using System.Windows;
using System.Windows.Controls;
using BingMapsDemo.Services;
using Microsoft.Maps.MapControl;
using BingMapsDemo.Business;

namespace BingMapsDemo
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            EarthquakeService.GetRecentEarthquakes((o, ea) =>
                {
                    ListOfEarthquakes.ItemsSource = ea.Locations;
                });
        }

        private void Pushpin_MouseEnter(object sender, System.Windows.Input.MouseEventArgs e)
        {
            FrameworkElement pin = sender as FrameworkElement;
            MapLayer.SetPosition(ContentPopup, MapLayer.GetPosition(pin));
            MapLayer.SetPositionOffset(ContentPopup, new Point(20, -15));

            var location = (EarthquakeLocation)pin.Tag;

            ContentPopupText.Text = location.Title;
            ContentPopupDescription.Text = location.Description;
            ContentPopup.Visibility = Visibility.Visible;
        }

        private void Pushpin_MouseLeave(object sender, System.Windows.Input.MouseEventArgs e)
        {
            ContentPopup.Visibility = Visibility.Collapsed;
        }
    }
}
