﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Xml.Linq;
using BingMapsDemo.Business;

namespace BingMapsDemo.Services
{
    public class EarthquakeService
    {
        public static void GetRecentEarthquakes(EventHandler<EarthquakeEventArgs> callback)
        {
            WebClient client = new WebClient();
            client.OpenReadCompleted += (o, e) =>
                {
                    XDocument doc = XDocument.Load(e.Result);

                    var data = (from eq in doc.Element("rss").Element("channel").Elements("item")
                                select new EarthquakeLocation()
                                {
                                    Title = eq.Element("title").Value,
                                    Description = eq.Element("description").Value,
                                    Location = new Microsoft.Maps.MapControl.Location(Convert.ToDouble(eq.Element(XName.Get("lat", "http://www.w3.org/2003/01/geo/wgs84_pos#")).Value), Convert.ToDouble(eq.Element(XName.Get("long", "http://www.w3.org/2003/01/geo/wgs84_pos#")).Value))
                                }).ToList();

                    callback(null, new EarthquakeEventArgs(data));
                };
            client.OpenReadAsync(new Uri("http://earthquake.usgs.gov/eqcenter/recenteqsww/catalogs/eqs7day-M2.5.xml"));
        }
    }

    public class EarthquakeEventArgs : EventArgs
    {
        public List<EarthquakeLocation> Locations { get; set; }

        public EarthquakeEventArgs(List<EarthquakeLocation> locations)
        {
            Locations = locations;
        }
    }
}
