﻿using System;
using System.Windows;
using System.Windows.Controls;
using Microsoft.Maps.MapControl;

namespace GeocodeService
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            PlatformServices.GeocodeServiceClient geocodeClient = new PlatformServices.GeocodeServiceClient("CustomBinding_IGeocodeService");

            PlatformServices.GeocodeRequest request = new PlatformServices.GeocodeRequest();
            request.Culture = MyMap.Culture;
            request.Query = QueryText.Text;

            request.Credentials = new Credentials();
            request.Credentials.ApplicationId = App.Current.Resources["MyCredentials"] as string;

            geocodeClient.GeocodeCompleted += new EventHandler<PlatformServices.GeocodeCompletedEventArgs>(client_GeocodeCompleted);
            geocodeClient.GeocodeAsync(request);
        }

        private void client_GeocodeCompleted(object sender, PlatformServices.GeocodeCompletedEventArgs e)
        {
            PlatformServices.GeocodeResponse response = e.Result;
            if (response.Results.Count > 0)
            {
                PlatformServices.GeocodeResult result = response.Results[0];
                if (result.Locations.Count > 0)
                {
                    MyMap.SetView(result.BestView);
                }
            }
        }
    }
}
