﻿using System;
using System.Windows;
using System.Windows.Controls;
using Microsoft.Maps.MapControl;

namespace ReverseGeocode
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            MyMap.MouseDoubleClick += new EventHandler<MapMouseEventArgs>(MyMap_MouseDoubleClick);
        }

        void MyMap_MouseDoubleClick(object sender, MapMouseEventArgs e)
        {
            Location location = MyMap.ViewportPointToLocation(e.ViewportPoint);

            PlatformServices.GeocodeServiceClient geocodeClient = new PlatformServices.GeocodeServiceClient("CustomBinding_IGeocodeService");
            PlatformServices.ReverseGeocodeRequest request = new PlatformServices.ReverseGeocodeRequest();
            request.Culture = MyMap.Culture;
            request.Credentials = new Credentials();
            request.Credentials.ApplicationId = App.Current.Resources["MyCredentials"] as string;
            request.Location = location;

            UIElement Marker = MyMap.FindName("Marker") as UIElement;
            MapLayer.SetPosition(Marker, location);
            MapLayer.SetPositionOrigin(Marker, PositionOrigin.Center);
            Marker.Visibility = Visibility.Visible;

            geocodeClient.ReverseGeocodeCompleted += new EventHandler<ReverseGeocode.PlatformServices.ReverseGeocodeCompletedEventArgs>(geocodeClient_ReverseGeocodeCompleted);
            ReverseGeocodeText.Text = "Reverse Geocoding...";
            geocodeClient.ReverseGeocodeAsync(request);

            e.Handled = true;
        }

        void geocodeClient_ReverseGeocodeCompleted(object sender, ReverseGeocode.PlatformServices.ReverseGeocodeCompletedEventArgs e)
        {
            string geocodeText = "No Information";
            if ((e.Result != null) && (e.Result.Results.Count > 0))
            {
                PlatformServices.GeocodeResult result = e.Result.Results[0];
                geocodeText = result.DisplayName;
            }

            ReverseGeocodeText.Text = geocodeText;
        }
    }
}
