﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Animation;

namespace BingMapsRotation
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void RotateZPause_Click(object sender, RoutedEventArgs e)
        {
            SpinZ.Pause();
        }

        private void RotateZStart_Click(object sender, RoutedEventArgs e)
        {
            if (SpinZ.GetCurrentState() != ClockState.Active)
            {
                SpinZ.Begin();
            }
            else
            {
                SpinZ.Resume();
            }
        }

        private void RotateXStart_Click(object sender, RoutedEventArgs e)
        {
            if (SpinX.GetCurrentState() != ClockState.Active)
            {
                SpinX.Begin();
            }
            else
            {
                SpinX.Resume();
            }

        }

        private void RotateXPause_Click(object sender, RoutedEventArgs e)
        {
            SpinX.Pause();
        }

        private void RotateYStart_Click(object sender, RoutedEventArgs e)
        {
            if (SpinY.GetCurrentState() != ClockState.Active)
            {
                SpinY.Begin();
            }
            else
            {
                SpinY.Resume();
            }

        }

        private void RotateYPause_Click(object sender, RoutedEventArgs e)
        {
            SpinY.Pause();
        }

        private void ZoomStart_Click(object sender, RoutedEventArgs e)
        {
            if (ZoomLevelAnimation.GetCurrentState() != ClockState.Active)
            {
                ZoomLevelAnimation.Begin();
            }
            else
            {
                ZoomLevelAnimation.Resume();
            }
        }

        private void ZoomPause_Click(object sender, RoutedEventArgs e)
        {
            ZoomLevelAnimation.Pause();
        }

        private void Reset_Click(object sender, RoutedEventArgs e)
        {
            ZoomLevelAnimation.Stop();
            SpinX.Stop();
            SpinY.Stop();
            SpinZ.Stop();

            MyMap.ZoomLevel = 2;
            Plane.RotationX = 0;
            Plane.RotationY = 0;
            Plane.RotationZ = 0;
        }

        private void StackPanel_MouseEnter(object sender, System.Windows.Input.MouseEventArgs e)
        {
            StackPanel s = sender as StackPanel;
            if (s != null)
            {
                s.Opacity = 0.8;
            }
        }

        private void StackPanel_MouseLeave(object sender, System.Windows.Input.MouseEventArgs e)
        {
            StackPanel s = sender as StackPanel;
            if (s != null)
            {
                s.Opacity = 0.2;
            }

        }

    }
}
